
/* ------------------------------------------------------------------------
   A. Veneziani - versione trasposta su file in C++ di esercizio precedente

                  Scritto in C++ Builder 6
   ------------------------------------------------------------------------ */

#include <iostream>
#include <fstream>
#include <string>

using namespace std;

int main()
{
    fstream fp, fp2;   // dichiara uno stream su un file (in lettura / scrittura)
    string linea;
    int num_m, num_f, alt_tot_m, alt_tot_f;
    int altezza;

    // apertura in scrittura dei dati letti delle altezze
    fp.open("altezze.txt",ios::out);

    do {
        cin >> linea;
        // se il valore letto non e' eof = ctrl-z, allora scrivilo nel file
        if (! cin.eof())  fp << linea << endl;
    } while (! cin.eof());     // ctrl + z = carattere di fine file

    fp.close();

    // lettura dei dati e calcolo  delle medie
    fp2.open("altezze.txt",ios::in);

    // inizializzazioni dei contatori e dei sommatori
    num_m = 0;
    num_f = 0;
    alt_tot_m = 0;
    alt_tot_f = 0;
    // finche' non giunge a fine file...
    while (! fp2.eof())
    {
        // leggi una linea
        fp2 >> linea;

        //  se quanto letto non e' eof
        if (! fp2.eof())
        {
            // controllo se maschio
            if ((linea == "M") || (linea == "m"))
            {
                fp2 >> altezza;      // legge l'altezza...
                alt_tot_m = alt_tot_m + altezza;     // ...e la mette in media
                num_m++;
            }

            // controllo se femmina
            if ((linea == "F") || (linea == "f"))
            {
                fp2 >> altezza;       // legge l'altezza...
                alt_tot_f = alt_tot_f + altezza;   // ...e la mette in media
                num_f++;
            }
        }
    }

    fp2.close();

    // apre in aiggunta in coda sul file (di testo)
    fp.open("altezze.txt", ios::out | ios::app);

    // indica la precisione con cui devono essere visualizzati i risultati    
    fp.setf(8,3);
    // output dei risultati...
    fp << "Altezza media maschi:  " << ((float) alt_tot_m) / num_m << endl;
    fp << "Altezza media femmine:  " << ((float) alt_tot_f) / num_f << endl << endl;

    cout << "Medie effettuate e scritte nel file." << endl;

    fp.close();

    system("PAUSE");   // attendi un pulsante...

    return(0);
}


